#include <stdio.h>
#include <stdlib.h>

    /* Obicno potenciranje x^n. */

double int_pow_mul(double x, int n)
{
    double pot = 1.0;
    int neg, i;

        /* Provjera x = 0. */
    if (x == 0.0) return 0.0;

        /* Zapamti predznak od n. */
    neg = n < 0;
    n = abs(n);

        /* Potenciranje mnozenjem. */
    for (i = 1; i <= n; ++i)
        pot *= x;

    if (neg) pot = 1.0 / pot;
    return pot;
}

int main(void)
{
    double x = 1.000000001;
    int n = 1000000000;

    printf(" Potencija %11.9f na %2d = %11.9f\n",
           x, n, int_pow_mul(x, n) );

    return 0;
}
