#include <stdio.h>

  /* Odgovor na pitanje: je li BAR JEDNA
     znamenka broja n u bazi b jednaka 5.
     Inicijalizacija je LAZ.
     Skracena varijanta koja prekida petlju
     ako nadje bar jednu trazenu znamenku.
     Unistava n dijeljenjem.
     Realizacija FUNKCIJOM.
  */

int odgovor(unsigned int n, unsigned int b,
            unsigned int trazena)
{
    while (n > 0) {
        if (n % b == trazena)
            return 1;
        n /= b;
    }
    return 0;
}

int main(void)
{
    unsigned int b = 10, trazena = 5, n;

    printf(" Upisi nenegativni broj n: ");
    scanf("%u", &n);
    printf("\n n = %u\n", n);

    if ( odgovor(n, b, trazena) )
        printf(" Odgovor je DA\n");
    else
        printf(" Odgovor je NE\n");

    return 0;
}
